// LeviathanDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Leviathan.h"
#include "LeviathanDlg.h"
#include "SqlFlow.h"
#include "netbios.h"
#include "SqlMod.h"
#include "RpcMod.h"
#include <lm.h>
#include <direct.h>

#pragma comment( lib, "netapi32" )
#pragma comment( lib, "mpr" )
#pragma comment( lib, "advapi32" )
#pragma comment( lib, "shell32" )
#pragma comment( lib, "shell32" )

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
struct TA
{
	char HostName[512];
	HWND WND;
}ta;
char *curPath;
char *repDir;
CString reportDir;
HANDLE hSema;

UINT NetBiosScan(LPVOID pParam)
{
	struct TA *arg;
	arg=(struct TA *)pParam;
	WaitForSingleObject(hSema,INFINITE);
	NetBiosModule *NetBios= new NetBiosModule(arg->HostName,arg->WND);
	::PostMessage(arg->WND,WM_STATICADD, (unsigned int)"Starting Netbios Analysis...",	0);
	if(NetBios->NullSession(1))
	{
		NetBios->DetectOS();
		::PostMessage(arg->WND,WM_THREADREADY,0,10);
		NetBios->EnumerateTOD();
		::PostMessage(arg->WND,WM_THREADREADY,0,10);
		NetBios->EnumerateShares();
		::PostMessage(arg->WND,WM_THREADREADY,0,10);
		NetBios->EnumerateUsers();
		::PostMessage(arg->WND,WM_THREADREADY,0,10);
		NetBios->EnumerateGroups();
		::PostMessage(arg->WND,WM_THREADREADY,0,10);
		NetBios->EnumerateServices();
		::PostMessage(arg->WND,WM_THREADREADY,0,10);
		NetBios->EnumerateSessions();
		::PostMessage(arg->WND,WM_THREADREADY,0,10);
		NetBios->EnumerateTransports();
		if(!NetBios->NullSession(0))
			::PostMessage(arg->WND,WM_STATICADD,
						(unsigned int)"Could not disconnect from the host.",0);

	}
	else
	{
		::PostMessage(arg->WND,WM_STATICADD,
						(unsigned int)"Could not connect to the host with default credidentals.",0);
		::PostMessage(arg->WND,WM_THREADREADY,0,70);
	}
	delete NetBios;
	::PostMessage(arg->WND,WM_THREADREADY,0,10);
	::PostMessage(arg->WND,WM_STATICADD,(unsigned int)"Finished Netbios Analysis.",	0);
	ReleaseSemaphore(hSema,1,NULL);
	return 0;
}
UINT SQLScan(LPVOID pParam)
{
	struct TA *arg;
	arg=(struct TA*)pParam;
	WaitForSingleObject(hSema,INFINITE);
	SqlModule *SQL= new SqlModule(arg->HostName,arg->WND);
	::PostMessage(arg->WND,WM_STATICADD,
						(unsigned int)"Starting SQL Server Analysis...",0);
	SQL->ScanHost();
	delete SQL;
	::PostMessage(arg->WND,WM_STATICADD, (unsigned int)"Finished SQL Server Analysis...",0);
	::PostMessage(arg->WND,WM_THREADREADY,0,10);
	ReleaseSemaphore(hSema,1,NULL);
	return 0;
}
UINT RPCScan(LPVOID pParam)
{
	struct TA *arg;
	arg=(struct TA*)pParam;
	WaitForSingleObject(hSema,INFINITE);
	RPCModule *RPC= new RPCModule(arg->HostName,arg->WND);
	::PostMessage(arg->WND,WM_STATICADD,
						(unsigned int)"Starting RPC Analysis...",0);
	RPC->EnumRPC();
	::PostMessage(arg->WND,WM_THREADREADY,0,10);
	delete RPC;
	::PostMessage(arg->WND,WM_STATICADD, (unsigned int)"Finished RPC Analysis...",0);
	ReleaseSemaphore(hSema,1,NULL);
	return 0;
}

UINT ResolveHost(LPVOID pParam)
{
	struct hostent *hp;
	WSADATA wsaData;
	struct sockaddr_in addr;
	char *buffer = new char[512];
	unsigned long ip;
	if (WSAStartup(MAKEWORD(2,1),&wsaData) == SOCKET_ERROR) 
	{
		 WSACleanup();
		 return -1;
	}
	if(!((ta.HostName[0] == '\\') && (ta.HostName[1]== '\\')))
		strcpy(buffer,ta.HostName);
	else
		strcpy(buffer,ta.HostName + 2);
	if((ip = inet_addr(buffer))== INADDR_NONE) 
	{   
		hp = gethostbyname(buffer);
		if(hp)
		{
			memcpy(&(addr.sin_addr),hp->h_addr,hp->h_length);
			strcpy(buffer,inet_ntoa(addr.sin_addr));
			ip = inet_addr(buffer);
		}
	}
	WSACleanup();
	strcpy(ta.HostName,buffer);
	delete [] buffer;
	ReleaseSemaphore(hSema,3,NULL);
	return 0;
}
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
LRESULT CLeviathanDlg::OnStartup(WPARAM wParam, LPARAM lParam)
{
	return 0L;
}

LRESULT CLeviathanDlg::OnError(WPARAM wParam, LPARAM lParam)
{
	if (lParam)
	{
		CString msg((char *)lParam);
		MessageBox(msg,"Audit Error", MB_ICONEXCLAMATION);
	}

	return 0L;
}

LRESULT CLeviathanDlg::OnReady(WPARAM wParam, LPARAM lParam)
{
	int i;
	i = m_Bar.OffsetPos((int)lParam);
	if(i == 90)
	{
		CMenu* pMenu = GetMenu();
		pMenu->EnableMenuItem(ID_FILE_VIEWREPORT,MF_ENABLED);
		m_Scan.EnableWindow(TRUE);
		m_Host.EnableWindow(TRUE);
		m_Bar.SetPos(0);
	}
	return 0L;
}

LRESULT CLeviathanDlg::OnShutdown(WPARAM wParam, LPARAM lParam)
{
	
	return 0L;
}

LRESULT CLeviathanDlg::OnDone(WPARAM wParam, LPARAM lParam)
{
	return 0L;
}

LRESULT CLeviathanDlg::OnStaticAdd(WPARAM wParam, LPARAM lParam)
{
	CListBox *list=(CListBox *)GetDlgItem(IDC_STATUS);
	list->AddString((char *)wParam);
	return 0L;
}

LRESULT CLeviathanDlg::OnDynamicAdd(WPARAM wParam, LPARAM lParam)
{
	CListBox *list=(CListBox *)GetDlgItem(IDC_STATUS);
	list->AddString((char *)wParam);
	delete [] (char *)wParam;
	return 0L;
}
CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLeviathanDlg dialog

CLeviathanDlg::CLeviathanDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLeviathanDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLeviathanDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLeviathanDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLeviathanDlg)
	DDX_Control(pDX, IDC_SCAN, m_Scan);
	DDX_Control(pDX, IDC_PROGRESSBAR, m_Bar);
	DDX_Control(pDX, IDC_STATUS, m_Status);
	DDX_Control(pDX, IDC_HOST, m_Host);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLeviathanDlg, CDialog)
	//{{AFX_MSG_MAP(CLeviathanDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SCAN, OnScan)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(ID_FILE_VIEWREPORT, OnFileViewreport)
	ON_COMMAND(ID_ACTION_CHOOSEREPORTFILE, OnActionChoosereportfile)
	ON_COMMAND(IDC_SQLAUDIT, OnSqlaudit)
	ON_COMMAND(ID_ACTION_RANGE, OnActionRange)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_ERROR, OnError)
	ON_MESSAGE(WM_THREADSTARTING, OnStartup)
	ON_MESSAGE(WM_THREADREADY, OnReady)
	ON_MESSAGE(WM_THREADSHUTDOWN, OnShutdown)
	ON_MESSAGE(WM_THREADDONE, OnDone)
	ON_MESSAGE(WM_STATICADD, OnStaticAdd)
	ON_MESSAGE(WM_DYNAMICADD, OnDynamicAdd)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLeviathanDlg message handlers

BOOL CLeviathanDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	curPath = new char[MAX_PATH];
	getcwd(curPath,MAX_PATH);
	reportDir.Format("%s\\leviathan.html",curPath);
	repDir = new char[MAX_PATH];
	m_Host.SetWindowText("www.sometarget.com");
	m_Bar.SetRange32( 0, 100 );
	return TRUE;  
}

void CLeviathanDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLeviathanDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLeviathanDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CLeviathanDlg::OnScan() 
{
	int pos = reportDir.ReverseFind('\\');
	char *temp = reportDir.GetBuffer(3);
	FILE *frame;
	memset(repDir,0,MAX_PATH);
	reportDir.ReleaseBuffer(-1);
	strncpy(repDir,temp,pos + 1);
	CMenu* pMenu = GetMenu();
	pMenu->EnableMenuItem(ID_FILE_VIEWREPORT,MF_DISABLED);
	m_Host.EnableWindow(FALSE);
	m_Scan.EnableWindow(FALSE);
	m_Bar.SetPos(0);
	if(!(frame = fopen(temp,"w")))
	{
		MessageBox("Could not open the file","Error",MB_OK);
		return;
	}
	fprintf(frame,"<html>\n");
	fprintf(frame,"<head>\n");
	fprintf(frame,"<title>Leviathan Audit Report</title>");
	fprintf(frame,"</head>");
	fprintf(frame, "<BR><FONT FACE=\"Arial\"><FONT SIZE=-1><A HREF = \"netbios.html\">Netbios Scan Results</A></FONT></FONT>\n");
	fprintf(frame, "<BR><FONT FACE=\"Arial\"><FONT SIZE=-1><A HREF = \"SQL.html\">SQL Scan Results</A></FONT></FONT>\n");
	fprintf(frame, "<BR><FONT FACE=\"Arial\"><FONT SIZE=-1><A HREF = \"RPC.html\">RPC Scan Results</A></FONT></FONT>\n");
	fprintf(frame,"</html>");
	fclose(frame);
	m_Status.SetColumnWidth(512);
	m_Status.ResetContent();
	m_Host.GetWindowText(ta.HostName,512);
	ta.WND = GetSafeHwnd();
	hSema = CreateSemaphore(NULL,0,3,NULL);
	CWinThread *pResThread = AfxBeginThread(ResolveHost,&ta,THREAD_PRIORITY_NORMAL);
	CWinThread *pNetBiosThread = AfxBeginThread(NetBiosScan, &ta,THREAD_PRIORITY_NORMAL);
	CWinThread *pSQLThread = AfxBeginThread(SQLScan,&ta,THREAD_PRIORITY_NORMAL);
	CWinThread *pRPCThread = AfxBeginThread(RPCScan,&ta,THREAD_PRIORITY_NORMAL);
}

void CLeviathanDlg::OnFileExit() 
{
	CLeviathanDlg::OnCancel();
}

void CLeviathanDlg::OnHelpAbout() 
{
	CAboutDlg ad;
	ad.DoModal();
}

void CLeviathanDlg::OnFileViewreport() 
{
	char cmd[MAX_PATH];
	sprintf(cmd,"file://%s",reportDir.GetBuffer(3));
	reportDir.ReleaseBuffer(-1);
	ShellExecuteA(NULL, "open", cmd, NULL, NULL, SW_SHOWNORMAL);
	
}

void CLeviathanDlg::OnActionChoosereportfile() 
{
	CFileDialog fileDialog(FALSE,"html", NULL,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"HTML Files (*.html)|*.html|All Files (*.*)|*.*||");

	if (fileDialog.DoModal() == IDOK)
		reportDir=fileDialog.GetPathName();
}

void CLeviathanDlg::OnSqlaudit() 
{
	CSqlFlow SQLWND;
	SQLWND.DoModal();
}

void CLeviathanDlg::OnActionRange() 
{
MessageBox("Not implemented yet",NULL,MB_OK);	
}
