//Netbios Class
#include "stdafx.h"
#include "netbios.h"
#include "leviathan.h"
#include "LeviathanDlg.h"

#include <lm.h>
#include <assert.h>
#include <lmcons.h>     // LAN Manager common definitions
#include <lmerr.h>      // LAN Manager network error definitions
#include <lmaccess.h>   // Access, Domain, Group and User classes
#include <lmshare.h>    // Connection, File, Session and Share classes
#include <lmapibuf.h>   // NetApiBuffer class
#include <ntsecapi.h>

extern char *repDir;

void lsastrcpy(PLSA_UNICODE_STRING lsastr, LPWSTR str) {
	if(!str) {
        lsastr->Buffer = NULL;
        lsastr->Length = 0;
        lsastr->MaximumLength = 0;
    } else {
		lsastr->Buffer = str;
		lsastr->Length = (USHORT)lstrlenW(str) * sizeof(WCHAR);
		lsastr->MaximumLength = lsastr->Length + sizeof(WCHAR);
	}
}
NetBiosModule::NetBiosModule(char *HostName , HWND Win)
{
	char pth[MAX_PATH];
	Host = new WCHAR[100];
	win = Win;
	char* buffer = new char[100];
	sprintf(pth,"%s\\netbios.html\0",repDir);
	if(!((HostName[0] == '\\') && (HostName[1]== '\\')))
	{
		strcpy(buffer,"\\\\");
		strcat(buffer,HostName);
	}
	else
		strcpy(buffer,HostName);
	mbstowcs( Host, buffer, (strlen(buffer)+1)*sizeof(WCHAR));
	delete [] buffer;
	if(!(HTMLFile = fopen(pth,"w")))
	{
	}
	wcscat(Host,L"\0");
	fprintf(HTMLFile, "<html>\n<head>\n<title>Leviathan Netbios Analysis</title>\n</head>\n");
	fprintf(HTMLFile, "<BODY topmargin=\"20px\" leftmargin=\"10px\">\n");
	fprintf(HTMLFile, "<CENTER><BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>Netbios Analysis Of %S</FONT></FONT></B></CENTER>\n",Host+2);
	fprintf(HTMLFile, "<P><FONT FACE=\"Arial\"><FONT SIZE=-1>\n");
	fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
}
NetBiosModule::~NetBiosModule()
{
	delete [] Host;
	WSACleanup();
	fprintf(HTMLFile,"</BODY>\n</HTML>\n");
	fclose(HTMLFile);
}
int NetBiosModule::NullSession( int Flag)
{
	LPCWSTR szIpc = L"\\IPC$";
	WCHAR RemoteResource[UNCLEN + 5 + 1];
	DWORD cchServer , Res;
	NET_API_STATUS nas;
	NETRESOURCE     nr;
	char *server;
	
	cchServer = lstrlenW( (LPWSTR)Host );
	if(Host[0] != L'\\' && Host[1] != L'\\') 
	{
		//
		// prepend slashes and NULL terminate
		//
		RemoteResource[0] = L'\\';
		RemoteResource[1] = L'\\';
		RemoteResource[2] = L'\0';
	}
	else
	{
		cchServer -= 2; // drop slashes from count
		RemoteResource[0] = L'\0';
	}
	if(cchServer > CNLEN)
	{
		return 0;
	}
	if(lstrcatW(RemoteResource, Host) == NULL)
		return 0;
	if(lstrcatW(RemoteResource, szIpc) == NULL)
		return 0;

	server = new char[wcslen(RemoteResource) + 1];
	wcstombs (server , RemoteResource, (wcslen (RemoteResource) + 1) * sizeof (WCHAR));
	strcat(server,"\0");

	nr.dwType = RESOURCETYPE_ANY;
	nr.lpLocalName = NULL;
	nr.lpProvider = NULL;
	nr.lpRemoteName=(LPTSTR)server;

	if(Flag == 1)
	{
		nas = WNetAddConnection2(&nr, (LPTSTR) "", (LPTSTR) "", 0);
		if( nas == NERR_Success )
		{
			delete [] server;
			return 1;
		}
		else
		{
			delete [] server;
			return 0;
		}
	}
	else
	{
		Res = WNetCancelConnection2((LPTSTR)server, 0,1);
		delete [] server;
		if(Res == NO_ERROR )
			return 1;
		else
			return 0;
	}
}
int NetBiosModule::DetectOS()
{
	DWORD dwLevel			= 101;
	LPSERVER_INFO_101 pBuf	= NULL;
	LPWKSTA_INFO_102  pwBuf = NULL; 
	NET_API_STATUS nStatus;
	LSA_UNICODE_STRING server;
	DWORD err;
	ULONG ret;
    LSA_OBJECT_ATTRIBUTES attrs;
	LSA_HANDLE hLsa;
	int errorFlag = 0 , rval = 0; 
	
	nStatus = NetServerGetInfo((LPTSTR)Host,dwLevel,(LPBYTE *)&pBuf);
	if (nStatus == NERR_Success)
	{
		if (pBuf->sv101_type & SV_TYPE_DOMAIN_CTRL)
		{
			fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>Machine %S is a Primary Domain Controller</FONT></FONT></B>",pBuf->sv101_name);
			fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
			rval = 5;
		}
		else if (pBuf->sv101_type & SV_TYPE_DOMAIN_BAKCTRL)
		{
			fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>Machine %S is a Domain Backup Controller</FONT></FONT></B>",pBuf->sv101_name);
			fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
			rval = 5;
		}
		else if (pBuf->sv101_type & SV_TYPE_SERVER_NT )
		{
			fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>Machine %S is an NT Member Server</FONT></FONT></B>",pBuf->sv101_name);
			fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
			rval = 5;
		}
		else if (pBuf->sv101_type &  SV_TYPE_NT )
		{
			fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>Machine %S is an NT workstation</FONT></FONT></B>",pBuf->sv101_name);
			fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
			rval = 5;
		}
		else if (pBuf->sv101_type & SV_TYPE_SQLSERVER)
		{
			fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>Machine %S is running SQL server</FONT></FONT></B>",pBuf->sv101_name);
			fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
			rval = 5;
		}
		else if (pBuf->sv101_type &  SV_TYPE_NOVELL )
		{
			fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>Machine %S a Novell Netware Server</FONT></FONT></B>",pBuf->sv101_name);
			fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
			rval = 6;
		}
		else if (pBuf->sv101_type &  SV_TYPE_WINDOWS )
		{
			fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>Machine %S is a Windows 9x</FONT></FONT></B>",pBuf->sv101_name);
			fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
			rval = 6;
		}
		else if (pBuf->sv101_type & SV_TYPE_WFW )
		{
			fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>Machine %S is a Windows For Workgroups</FONT></FONT></B>",pBuf->sv101_name);
			fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
			rval = 6;
		}
		
		fprintf(HTMLFile,"<BR><B>Platform ID :</B>%d\n",pBuf->sv101_platform_id);
		fprintf(HTMLFile,"<BR><B>Version  :</B> %d.%d\n",pBuf->sv101_version_major,pBuf->sv101_version_minor);
	}
	else
	{
		if (pBuf != NULL)
			NetApiBufferFree(pBuf);
		errorFlag += 1;
	}
	dwLevel = 102;
	nStatus = NetWkstaGetInfo((char*)Host, dwLevel, (LPBYTE *)&pwBuf);
	if (nStatus == NERR_Success) 
	{ 
	  rval =6;
      fprintf(HTMLFile,"<BR><B>Domain :</B> %S\n",pwBuf->wki102_langroup);
	  fprintf(HTMLFile,"<BR><B>Logged On Users :</B> %d\n",pwBuf->wki102_logged_on_users);
	} 
	else 
		errorFlag += 1;
	if (pBuf != NULL)
			NetApiBufferFree(pBuf);
	if (pwBuf != NULL) 
			NetApiBufferFree(pwBuf);
	if(errorFlag == 2)
		return 2;
	ZeroMemory(&attrs, sizeof(attrs));
	lsastrcpy(&server, Host);
    err = LsaOpenPolicy(&server, &attrs, POLICY_VIEW_LOCAL_INFORMATION|POLICY_LOOKUP_NAMES, &hLsa);
	if (err < 0) 
		return rval;
    PVOID buff;
	if ((ret = LsaQueryInformationPolicy(hLsa,PolicyAccountDomainInformation,&buff)) >= 0) 
	{
		PPOLICY_ACCOUNT_DOMAIN_INFO info = (PPOLICY_ACCOUNT_DOMAIN_INFO) buff;
		wchar_t buf[100];
		wcsncpy (buf, info->DomainName.Buffer, info->DomainName.Length/2);
		buf[info->DomainName.Length/2] = L'\0';
        fprintf(HTMLFile,"<BR><B>Netbios Name :</B> %S\n",buf);
		LsaFreeMemory(buff);
    } 
    if (LsaQueryInformationPolicy(hLsa,PolicyPrimaryDomainInformation,&buff) >= 0) 
	{
		PPOLICY_PRIMARY_DOMAIN_INFO info = (PPOLICY_PRIMARY_DOMAIN_INFO)buff;
		wchar_t buf[100];
		wcsncpy (buf, info->Name.Buffer, info->Name.Length/2);
		buf[info->Name.Length/2] = L'\0';
        fprintf(HTMLFile,"<BR><B>Domain Name:</B> %S\n",buf);
		LsaFreeMemory(buff);
	} 
	LSA_ENUMERATION_HANDLE hEnum = 0;
	unsigned int pass = 1;
	do 
	{
		LONG ret = 0;
		ULONG count;
		ret = LsaEnumerateTrustedDomains(hLsa,&hEnum,&buff,1000,&count);
        if (ret < 0) 
		{
			if (pass == 1)
				if (ret != 0x8000001a) 
					fprintf(HTMLFile,"<BR><B>None</B>\n");
			break;
		}
		else
			if(pass == 1)
				fprintf(HTMLFile,"<BR><B>Trusted Domains</B>\n");
        wchar_t buf[100];
        PLSA_TRUST_INFORMATION info = (PLSA_TRUST_INFORMATION)buff;
		unsigned int i;
        for (i=0; i<count; i++) 
		{
			wcsncpy (buf, info[i].Name.Buffer, info[i].Name.Length/2);
			buf[info[i].Name.Length/2] = L'\0';
	        fprintf(HTMLFile,"<BR>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp%S\n",buf);

		}
		pass++;
	} while ((err != ERROR_NO_MORE_ITEMS) && (err != 0x8000001a)); 
	return rval;
}
int NetBiosModule::EnumerateGroups()
{
	
	DWORD ret, read, total, resume = 0;
	LPVOID buff;
	fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
	fprintf(HTMLFile, "<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>Groups: %S</FONT></FONT></B>",Host + 2); 
	fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
	do {
		ret = NetLocalGroupEnum(Host, 0, (unsigned char **)&buff, 1024, &read, &total, &resume);
		if (ret != NERR_Success && ret != ERROR_MORE_DATA) 
			break;
        PLOCALGROUP_INFO_0 info = (PLOCALGROUP_INFO_0) buff;
        unsigned t;
		for (t=0; t<read; t++) 
		{
			fprintf(HTMLFile,"<BR><B>%S</B>\n",info[t].lgrpi0_name);
			DWORD ret, read, total, resume = 0;
			ret = NetLocalGroupGetMembers(Host, info[t].lgrpi0_name, 3, 
			                          (unsigned char **)&buff, 1024, &read, &total, &resume);
			if (ret != NERR_Success && ret != ERROR_MORE_DATA) 
		    	return 0;
            PLOCALGROUP_MEMBERS_INFO_3 info = (PLOCALGROUP_MEMBERS_INFO_3) buff;
            for (unsigned i=0; i<read; i++) 
					fprintf(HTMLFile,"<BR>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp%S\n",info[i].lgrmi3_domainandname);
            NetApiBufferFree (buff);
		}
		NetApiBufferFree (buff);
	} while (ret == ERROR_MORE_DATA );
	return 1;
}
int NetBiosModule::EnumerateServices()
{
	SC_HANDLE scm;
	BOOL success;
	LPENUM_SERVICE_STATUS status;
	DWORD numServices=0, sizeNeeded=0, resume=0;
	char *server;
	server = new char[wcslen(Host) + 1];
	wcstombs (server, Host, (wcslen (Host) + 1) * sizeof (WCHAR));
	strcat(server,"\0");
	// Open a connection to the SCM
	scm = OpenSCManager(server, 0, GENERIC_READ);
	if (!scm)
		return 0;
	// get the number of bytes to allocate

	success = EnumServicesStatus(scm,
								SERVICE_WIN32 | SERVICE_DRIVER,
	                            SERVICE_ACTIVE | SERVICE_INACTIVE,
	                            0, 0, &sizeNeeded,
								&numServices, &resume);

	if (GetLastError() != ERROR_MORE_DATA)
		return 0;
	// Allocate space
	status = (LPENUM_SERVICE_STATUS)
	LocalAlloc(LPTR, sizeNeeded);
	resume = 0;
	success = EnumServicesStatus(scm,
								 SERVICE_WIN32 | SERVICE_DRIVER,
	                             SERVICE_ACTIVE,
	                             status, sizeNeeded, &sizeNeeded,
	                             &numServices,
								 &resume);
	if (!success)
		return 0;
	DWORD i;
	fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
	fprintf(HTMLFile, "<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>Services of %S</FONT></FONT></B>",Host + 2); 
	fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");

	for (i=0; i < numServices; i++)
	{
		fprintf(HTMLFile,"<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>");
		fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+0>%s</FONT></FONT></B>",status[i].lpServiceName);
		fprintf(HTMLFile,"<BR> %s.",status[i].lpDisplayName);
		fprintf(HTMLFile,"<BR><IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>");
	}
	LocalFree(status);
	CloseServiceHandle(scm);
	delete [] server;
	return 1;
}
int NetBiosModule::EnumerateSessions()
{
   LPSESSION_INFO_10 pBuf = NULL; 
   LPSESSION_INFO_10 pTmpBuf; 
   DWORD dwLevel = 10; 
   DWORD dwPrefMaxLen = 0xFFFFFFFF; 
   DWORD dwEntriesRead = 0; 
   DWORD dwTotalEntries = 0; 
   DWORD dwResumeHandle = 0; 
   DWORD i; 
   DWORD dwTotalCount = 0; 
   LPTSTR pszClientName = NULL; 
   LPTSTR pszUserName = NULL; 
   NET_API_STATUS nStatus;
   
    fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
	fprintf(HTMLFile, "<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>Current Sessions On %S</FONT></FONT></B>",Host + 2); 
	fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
   do 
    { 
      nStatus = NetSessionEnum((LPTSTR)Host, 
                               pszClientName, 
                               pszUserName, 
                               dwLevel, 
                               (LPBYTE*)&pBuf, 
                               dwPrefMaxLen, 
                               &dwEntriesRead, 
                               &dwTotalEntries, 
                               &dwResumeHandle); 
 
      if ((nStatus == NERR_Success) || (nStatus == ERROR_MORE_DATA)) 
      { 
		 if ((pTmpBuf = pBuf) != NULL) 
         { 
            for (i = 0; i < dwEntriesRead; i++) 
            { 
               assert(pTmpBuf != NULL); 
			   if (pTmpBuf == NULL) 
               { 
                  break; 
               } 
               fprintf(HTMLFile,"<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>");
			   fwprintf(HTMLFile,L"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+0>Client : %s</FONT></FONT></B>",pTmpBuf->sesi10_cname);
			   fwprintf(HTMLFile,L"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+0>User   : %s</FONT></FONT></B>",pTmpBuf->sesi10_username);
			   fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+0>Active   : %d</FONT></FONT></B>",pTmpBuf->sesi10_time);
			   fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+0>Idle     : %d</FONT></FONT></B>",pTmpBuf->sesi10_idle_time);
			   fprintf(HTMLFile,"<BR><IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>");
			   pTmpBuf++; 
               dwTotalCount++; 
            } 
         } 
      }
      if (pBuf != NULL) 
      { 
         NetApiBufferFree(pBuf); 
         pBuf = NULL; 
      } 
   } while (nStatus == ERROR_MORE_DATA); 
   if (pBuf != NULL) 
      NetApiBufferFree(pBuf); 
   return 1; 
}
int NetBiosModule::EnumerateShares()
{
	PSHARE_INFO_1 BufPtr,p;
	NET_API_STATUS res;
	DWORD i = 0;
	DWORD entriesread=0, resume_handle=0, totalentries=0;
	fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
	fprintf(HTMLFile, "<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>Shares of %S</FONT></FONT></B>",Host + 2); 
	fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
	
	do
	{
		res = NetShareEnum((LPTSTR)Host,
							 1,
							 (LPBYTE *) &BufPtr,
							 0xFFFFFFFF,
							 &entriesread,
							 &totalentries,
							 &resume_handle);

		if(res == ERROR_SUCCESS || res == ERROR_MORE_DATA)
		{
			p = BufPtr;
			for(i=0;i<entriesread;i++)
			{
				fprintf(HTMLFile,"<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>");
				fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+0>%S</FONT></FONT></B>",p->shi1_netname);
				fprintf(HTMLFile,"<BR> %S.",p->shi1_remark);
				fprintf(HTMLFile,"<BR><IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>");
				p++;
			}
			NetApiBufferFree(BufPtr);
		}
		else
		{
			return 0;
		}
	}while (res==ERROR_MORE_DATA);

	return 1;
}
int NetBiosModule::EnumerateTOD()
{
   LPTIME_OF_DAY_INFO pBuf = NULL;
   NET_API_STATUS nStatus;
   //
   // Call the NetRemoteTOD function.
   //
   nStatus = NetRemoteTOD(Host,
                          (LPBYTE *)&pBuf);
   //
   // If the function succeeds, display the current date and time.
   //
   if (nStatus == NERR_Success)
   {
	  if (pBuf != NULL)
      {
         fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=-1>Remote Date:</B> %d/%d/%d</FONT></FONT>\n",
			 pBuf->tod_month,pBuf->tod_day,pBuf->tod_year);
         fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=-1>Remote Time: </B>%lu:%lu:%lu</FONT></FONT>\n",
			 pBuf->tod_hours + 4,pBuf->tod_mins,pBuf->tod_secs);
		 fprintf(HTMLFile,"<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
		 NetApiBufferFree(pBuf);
	   }
   }else
	   return 0;
   return 1;
      
}
int NetBiosModule::EnumerateTransports()
{
   LPSERVER_TRANSPORT_INFO_0 pBuf = NULL;
   LPSERVER_TRANSPORT_INFO_0 pTmpBuf;
   DWORD dwLevel = 0;
   DWORD dwPrefMaxLen = 256; 
   DWORD dwEntriesRead = 0;
   DWORD dwTotalEntries = 0;
   DWORD dwResumeHandle = 0;
   DWORD dwTotalCount = 0;
   NET_API_STATUS nStatus;
   DWORD i;
    fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
	fprintf(HTMLFile, "<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>Transport devices of %S</FONT></FONT></B>",Host + 2); 
	fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");

   //
   do // begin do
   {
      nStatus = NetServerTransportEnum((LPTSTR)Host,
                                       dwLevel,
                                       (LPBYTE *) &pBuf,
                                       dwPrefMaxLen,
                                       &dwEntriesRead,
                                       &dwTotalEntries,
                                       &dwResumeHandle);
      //
      // If the call succeeds,
      //
      if ((nStatus == NERR_Success) || (nStatus == ERROR_MORE_DATA))
      {
         if ((pTmpBuf = pBuf) != NULL)
         {
            //
            // Loop through the entries;
            //  process access errors.
            //
            for (i = 0; i < dwEntriesRead; i++)
            {
               assert(pTmpBuf != NULL);
               if (pTmpBuf == NULL)
               {
                  break;
               }
               //
               // Print the transport protocol name. 
               //
               fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+0>Device : %S</FONT></FONT></B>",pTmpBuf->svti0_transportname);
			   fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+0>Address: %S</FONT></FONT></B>",pTmpBuf->svti0_networkaddress);
               pTmpBuf++;
               dwTotalCount++;
            }
         }
      }
      if (pBuf != NULL)
      {
         NetApiBufferFree(pBuf);
         pBuf = NULL;
      }
   // 
   // Continue to call NetServerTransportEnum while 
   //  there are more entries. 
   // 
   }
   while (nStatus == ERROR_MORE_DATA); // end do

   // Check again for an allocated buffer.
   //
   if (pBuf != NULL)
      NetApiBufferFree(pBuf);
   //
   // Print the final count of transports enumerated.
   return 1;
}
int NetBiosModule::EnumerateUsers()
{
	PNET_DISPLAY_USER pBuff, p;
	DWORD res, dwRec, i = 0;

	fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
	fprintf(HTMLFile, "<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+1>Users: %S</FONT></FONT></B>",Host + 2); 
	fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");

	do
	{
		res = NetQueryDisplayInformation(Host, 1, i, 1000, 1000*sizeof(NET_DISPLAY_USER), &dwRec, (PVOID *)&pBuff);
		//NetUserGetInfo(
  		if((res==ERROR_SUCCESS) || (res==ERROR_MORE_DATA))
		{
			p = pBuff;
			
			for(;dwRec>0;dwRec--)
			{
				
				fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%>\n");
				fprintf(HTMLFile,"<BR><B><FONT FACE=\"Arial\"><FONT SIZE=+0>%S : %S</FONT></FONT></B>",p->usri1_name,p->usri1_comment);
				fprintf(HTMLFile,"<BR><B>Full Name : </B> %S",p->usri1_full_name);
				fprintf(HTMLFile,"<BR><B>ID        :</B> %u\n",p->usri1_user_id);
				fprintf(HTMLFile,"<BR><B>Comments  :</B>");
				if (p->usri1_flags & UF_NORMAL_ACCOUNT)
					fprintf(HTMLFile,"<BR>This is a default account type that represents a typical user.\n");
				if (p->usri1_flags & UF_TEMP_DUPLICATE_ACCOUNT)
					fprintf(HTMLFile,"<BR>This is an account for users whose primary account is in another domain. This account provides user access to this domain, but not to any domain that trusts this domain. The User Manager refers to this account type as a local user account.\n");
				if (p->usri1_flags & UF_SCRIPT)
					fprintf(HTMLFile,"<BR>The logon script executed.This value must be set for LAN Manager 2.0 or Windows NT.\n");
				if (p->usri1_flags & UF_ACCOUNTDISABLE)
					fprintf(HTMLFile,"<BR>The user's account is disabled.");
				if (p->usri1_flags & UF_HOMEDIR_REQUIRED)
					fprintf(HTMLFile,"<BR>The home directory is required. Windows NT ignores this value.\n");
				if (p->usri1_flags & UF_PASSWD_NOTREQD)
					fprintf(HTMLFile,"<BR>No password is required.");
				if (p->usri1_flags & UF_PASSWD_CANT_CHANGE )
					fprintf(HTMLFile,"<BR>The user cannot change the password.\n");
				if (p->usri1_flags & UF_LOCKOUT)
					fprintf(HTMLFile,"<BR>The Account is Locked.\n");
				if (p->usri1_flags & UF_DONT_EXPIRE_PASSWD)
					fprintf(HTMLFile,"<BR>Password does not expire.\n");
				if (p->usri1_flags & UF_WORKSTATION_TRUST_ACCOUNT)
					fprintf(HTMLFile,"<BR>This is a computer account for a Windows NT Workstation or Windows NT Server that is a member of this domain.\n");
				if (p->usri1_flags & UF_SERVER_TRUST_ACCOUNT)
					fprintf(HTMLFile,"<BR>This is a computer account for a Windows NT Backup Domain Controller that is a member of this domain.\n");
				if (p->usri1_flags & UF_INTERDOMAIN_TRUST_ACCOUNT)
					fprintf(HTMLFile,"<BR>This is a permit to trust account for a Windows NT domain that trusts other domains.\n");
				i = p->usri1_next_index;  //if there is more then set the index
				p++;
			}
			NetApiBufferFree(pBuff);
			fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%></BLOCKQUOTE>\n");
			return 1;
		}
		else
		{
			fprintf(HTMLFile, "<IMG SRC=\"black.gif\" VSPACE=3 HEIGHT=1 WIDTH=100%%></BLOCKQUOTE>\n");
			return 0;
		}
	}while (res == ERROR_MORE_DATA);
}

